/*
IMG unpack plugin
Copyright (C) 2002 IvGzury
	ivgzury@hotmail.com

changes for FAT12/FAT16/FAT32 drive images and long filenames
by Holger Klabunde

 hk@holger-klabunde.de
 http://www.holger-klabunde.de

This program is absolutely free software.
If you have any remarks or problems, please don't
hesitate to send me an email.

It was made for Windows Commander.
Windows Commander: is an excellent file manager 
                   made by Christian Ghisler
*/

#include "stdafx.h"
#include <stdio.h>
#include "imgwcx.h"

unsigned long bootoffset;  //Offset to bootsector in sectors
unsigned int bps;          //Bytes per Sector. if bigger than 512 !
unsigned long clusterSize; //
unsigned long endcluster;  //endcluster mark
unsigned long endoffile;   //not used
int FATtype;
char longname[260];        //buffer for long filenames
int longcount;             //long filename entrys found (for one file)
unsigned char longoffset;  //offset in longname[]

char w[256];               //not used

tChangeVolProc pGlobChangeVol;
tProcessDataProc pGlobProcessData;

//#####################################################
// The DLL entry point
BOOL APIENTRY DllMain( HANDLE hModule,DWORD  ul_reason_for_call,LPVOID lpReserved)
//#####################################################
{	return TRUE; }


//#####################################################
unsigned long NextClus(unsigned long firstclus,tArchive *arch)
//#####################################################
{
 unsigned long tmp,n;

 tmp=0;

 if(FATtype==FAT12)
  {
    n= (firstclus * 3) >>1 ; //multiply by 1.5 (rounds down)

    if(n>=(BUFFSIZE-1))
     {
      MessageBox(NULL,"FAT Buffer Overrun",NULL,MB_OK);
      return endcluster;
     }

    tmp=MakeUINT(&arch->fattable->data[n]);

	if (firstclus&0x01) tmp>>=4; //shift to right position
    else                tmp&=0xFFF; //delete high nibbles
  }

 if(FATtype==FAT16)
  {
    n=firstclus*2;

    if(n>=(BUFFSIZE-1))
     {
      MessageBox(NULL,"FAT Buffer Overrun",NULL,MB_OK);
      return endcluster;
     }

    tmp=MakeUINT(&arch->fattable->data[n]);
  }

 if(FATtype==FAT32)
  {
    n=firstclus*4;

    if(n>=(BUFFSIZE-3))
     {
      MessageBox(NULL,"FAT Buffer Overrun",NULL,MB_OK);
      return endcluster;
     }

    tmp=MakeULONG(&arch->fattable->data[n]);
    tmp&=0x0FFFFFFF; //delete four highest bits
  }

 return tmp;
}

//#####################################################
int CreateFileList(const char* root,unsigned long firstclus,tArchive *arch,unsigned long depth)
//#####################################################
{
	tDirEntry *newentry;
	tDirSector *sector=NULL;

	unsigned long i,j,stop;
	unsigned long result;
    int attr;

	if (firstclus==0)
	{
		SetFilePointer(arch->hArchFile,arch->rootarea*bps,0,FILE_BEGIN);
	} else {
		SetFilePointer(arch->hArchFile
                       ,(arch->dataarea *bps) + ((firstclus-2) * clusterSize) 
                       ,0,FILE_BEGIN);
	}

	sector = new tDirSector;
	if (sector==NULL) goto error;
    if ((firstclus==1) || (firstclus>=endcluster))
     {
      goto error;
     }

    if(firstclus==0)
     {
	  ReadFile(arch->hArchFile, sector, bps, &result, 0);
      stop=(bps/32);
	  if (result!=bps) goto error;
     }
    else
     {
	  ReadFile(arch->hArchFile, sector, clusterSize, &result, 0);
      stop=(clusterSize/32);
	  if (result!=clusterSize) goto error;
     }

	i=1;
	do {
		j=0;
		while ((j<stop)&&(sector->data[j].DIR_Name[0]!=char(0x00)))
		{
			if ((newentry = new tDirEntry)==NULL)
             {
              goto error;
             }
              
            attr=DIR_AttrToFileAttr(sector->data[j].DIR_Attr,&newentry->FileAttr); 

            if(attr==AT_LONG && sector->data[j].DIR_Name[0]!=char(0xE5)
               && sector->data[j].DIR_FstClusLO==0 && sector->data[j].DIR_NTRes==0
              ) //long name entry found
             {
              if(sector->data[j].DIR_Name[0] & 0x40) //new long name ?
               {
                memset(longname, 0, 260); //delete last entry
                longcount=0;
               }

              longoffset=sector->data[j].DIR_Name[0]; //get offset in longname[] array
              longoffset&=~0x40; //set bit D6 to zero

              if(longoffset<=20) //don't write beyond array
               {
                longoffset--; //array begins at 0
                longoffset*=13; //set offset for new entry

                //what's coming now is experimental, but it works for me
                //i do not translate UNICODE chars ! only take the low byte
                //no check if char is valid

//#############################################################################
//Todo:
//struct LongName als UNION und dann ber Arrays arbeiten. Besser als mit den
//Variablen des Verzeichniseintrages unten zu arbeiten ;)
//#############################################################################

                longname[longoffset]=sector->data[j].DIR_Name[1];
                longname[longoffset+1]=sector->data[j].DIR_Name[3];
                longname[longoffset+2]=sector->data[j].DIR_Name[5];
                longname[longoffset+3]=sector->data[j].DIR_Name[7];
                longname[longoffset+4]=sector->data[j].DIR_Name[9];

                longname[longoffset+5]=(unsigned char)(sector->data[j].DIR_CrtTime & 0xFF);
                longname[longoffset+6]=(unsigned char)(sector->data[j].DIR_CrtDate & 0xFF);
                longname[longoffset+7]=(unsigned char)(sector->data[j].DIR_LstAccDate & 0xFF);
                longname[longoffset+8]=(unsigned char)(sector->data[j].DIR_FstClusHI & 0xFF);
                longname[longoffset+9]=(unsigned char)(sector->data[j].DIR_WrtTime & 0xFF);
                longname[longoffset+10]=(unsigned char)(sector->data[j].DIR_WrtDate & 0xFF);
                longname[longoffset+11]=(unsigned char)(sector->data[j].DIR_FileSize & 0xFF);
                longname[longoffset+12]=(unsigned char)((sector->data[j].DIR_FileSize >>16) & 0xFF);

                longcount++; //count up flag "found another longname entry"
              }
             }

			switch (attr)
			{
			case AT_LONG:
			case AT_VOL:
			case AT_INVALID:{delete newentry; j++; continue;};
			}

			switch (DIR_NameToFileName(sector->data[j].DIR_Name,newentry->FileName))
			{
			case DN_UNKNOWN:
			case DN_DELETED:{delete newentry; j++; continue;};
			}

			strcpy(newentry->PathName,"");
			if (root!="") 
			{
				strcpy(newentry->PathName,root);
				strcat(newentry->PathName,"\\");
			}

//			strcat(newentry->PathName,newentry->FileName);

            if(longcount>0)
             {
  			  strcat(newentry->PathName,longname); //use long filename
             }
            else
             {
  			  strcat(newentry->PathName,newentry->FileName); //use 8.3 filename
             }

			newentry->FileTime=((unsigned long)(sector->data[j].DIR_WrtDate)<<16)
                                + sector->data[j].DIR_WrtTime;

			newentry->FileSize=sector->data[j].DIR_FileSize;

			newentry->FirstClus=((unsigned long)(sector->data[j].DIR_FstClusHI)<<16)
                                + sector->data[j].DIR_FstClusLO;

			newentry->next=NULL;
			newentry->prev=arch->entrylist;
			if (arch->entrylist!=NULL) arch->entrylist->next=newentry;
			arch->entrylist=newentry;

            longcount=0; //reset longname entry count

			if ( (newentry->FileAttr & ATTR_DIRECTORY) &&
			     (newentry->FirstClus<endcluster) && (newentry->FirstClus>0x1) 
			     && (depth<=100))
			{
				CreateFileList(newentry->PathName,newentry->FirstClus,arch,depth+1);
			}

			j++;
		}

		if (j<stop) goto error;
		if ((firstclus==0)&&((i*bps/32)>=arch->rootentcnt))
         {
//          MessageBox(NULL,"RootDir Overrun",NULL,MB_OK);
          goto error;
         }
		if (firstclus==0)
		{
			SetFilePointer(arch->hArchFile,(arch->rootarea+i)*bps,0,FILE_BEGIN);
		    ReadFile(arch->hArchFile, sector, bps, &result, 0);
		    if (result!=bps) goto error;
		} else {
			firstclus=NextClus(firstclus,arch);
			if ((firstclus<=1) || (firstclus>=endcluster))
             {
              goto error;
             }

			SetFilePointer(arch->hArchFile
                           ,(arch->dataarea * bps) + (firstclus-2) * clusterSize
                           ,0,FILE_BEGIN);

  		    ReadFile(arch->hArchFile, sector, clusterSize, &result, 0);
		    if (result!=clusterSize) goto error;
		}

		i++;
	} while (true);
error:
	if (sector!=NULL) delete sector;
	return 0;
}

//#####################################################
myHANDLE IMG_Open(tOpenArchiveData *ArchiveData) 
//#####################################################
{
   unsigned long TotalSec;
   unsigned long CountofClusters;

	tArchive *arch=NULL;
	struct tFAT12BootSec bootsec;
	unsigned long result;

    bps=512; //have not seen a drive with bigger sectors !

	ArchiveData->CmtBuf     = 0;
	ArchiveData->CmtBufSize = 0;
	ArchiveData->CmtSize    = 0;
	ArchiveData->CmtState   = 0;

	ArchiveData->OpenResult=E_NO_MEMORY;// default error type
	if ((arch = new tArchive)==NULL) { return NULL;	}

	// trying to open
	memset(arch, 0, sizeof(tArchive));
	strcpy(arch->archname,ArchiveData->ArcName);
	arch->hArchFile=CreateFile(arch->archname,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,0,0);
	if (arch->hArchFile == INVALID_HANDLE_VALUE) { goto error; }

    //read first sector in image
	ReadFile(arch->hArchFile, &bootsec, sizeof(struct tFAT12BootSec), &result, 0);
	if (result!=sizeof(struct tFAT12BootSec))
	{
		ArchiveData->OpenResult=E_EREAD;
		goto error;
	}

    bootoffset=0; //this is true for floppy images

    //try to find out if this is a floppy bootsector or a partitiontable
    //on a harddrive. does anyone know a better way ? "FAT12" never
    //appears in a partitiontable, so it must be a bootsector.
    //if it is a bootsector and "FAT12" doesn't exist here, than we
    //have a big problem :(

    FATtype=0;
    if(strncmp(bootsec.eb.eb12.BS_FilSysType,"FAT12",5)==NULL) FATtype=FAT12;
    if(strncmp(bootsec.eb.eb12.BS_FilSysType,"FAT16",5)==NULL) FATtype=FAT16;
    if(strncmp(bootsec.eb.eb32.BS_FilSysType,"FAT32",5)==NULL) FATtype=FAT32;

    if(FATtype==0)
     {
      //seems to be a partitiontable so get bootsector offset
      //from first partition entry at offset 0x01BE + 8
	  SetFilePointer(arch->hArchFile,PART0_TABLE_OFFSET+8,0,FILE_BEGIN);
	  ReadFile(arch->hArchFile, &bootoffset, sizeof(unsigned long), &result, 0);
	  if (result!=sizeof(unsigned long))
	   {
		ArchiveData->OpenResult=E_EREAD;
		goto error;
	   }

      //read bootsector at bootoffset
	  SetFilePointer(arch->hArchFile,bootoffset*bps,0,FILE_BEGIN);
	  ReadFile(arch->hArchFile, &bootsec, sizeof(struct tFAT12BootSec), &result, 0);
	  if (result!=sizeof(struct tFAT12BootSec))
	   {
		ArchiveData->OpenResult=E_EREAD;
		goto error;
	   }

      if(strncmp(bootsec.eb.eb12.BS_FilSysType,"FAT12",5)==NULL) FATtype=FAT12;
      if(strncmp(bootsec.eb.eb12.BS_FilSysType,"FAT16",5)==NULL) FATtype=FAT16;
      if(strncmp(bootsec.eb.eb32.BS_FilSysType,"FAT32",5)==NULL) FATtype=FAT32;
     } 

/* forget this
	if ( (bootsec->BPB_BytesPerSec[0]!=0x00) ||
	     (bootsec->BPB_BytesPerSec[1]!=0x02)
       ||(bootsec->BPB_SecPerClus==0x00)
       )
*/
	if(bootsec.BPB_SecPerClus==0x00 || FATtype==0)
	{
     MessageBox(NULL,"Unknown Fat Format",NULL,MB_OK);
		ArchiveData->OpenResult=E_UNKNOWN_FORMAT;
		goto error;
	}

    clusterSize=bootsec.BPB_SecPerClus*bps;

	arch->fatsize= bootsec.BPB_FATSz16;

    TotalSec=bootsec.BPB_TotSec16;
    if(TotalSec==0) TotalSec=bootsec.BPB_TotSec32;

    if(TotalSec==0)
     {
      MessageBox(NULL,"Unknown Fat Format",NULL,MB_OK);
    	ArchiveData->OpenResult=E_UNKNOWN_FORMAT;
		goto error;
     }

    if(arch->fatsize==0) arch->fatsize= bootsec.eb.eb32.BPB_FATSz32;

	if ( arch->fatsize<1 )
	{
     MessageBox(NULL,"FatTableSize NULL",NULL,MB_OK);
		ArchiveData->OpenResult=E_UNKNOWN_FORMAT;
		goto error;
	}

	if ( arch->fatsize>BUFFSIZE/bps )
	{
     MessageBox(NULL,"FatTableSize too big",NULL,MB_OK);
		ArchiveData->OpenResult=E_UNKNOWN_FORMAT;
		goto error;
	}

	arch->rootentcnt= bootsec.BPB_RootEntCnt;

//forget this
//	if ( arch->rootentcnt>0xE0) //224 is the maximum in a 1.44 floppy
//	{
//		ArchiveData->OpenResult=E_UNKNOWN_FORMAT;
//		goto error;
//	}

    arch->rootarea= bootsec.BPB_RsvdSecCnt + arch->fatsize*bootsec.BPB_NumFATs;
    arch->dataarea= arch->rootarea + ((arch->rootentcnt*32)+bps-1)/bps;

    CountofClusters=(TotalSec-arch->dataarea)/bootsec.BPB_SecPerClus;

    if(FATtype==FAT12) { endcluster=0xFF0; }
    if(FATtype==FAT16) { endcluster=0xFFF0;}
    if(FATtype==FAT32) { endcluster=0xFFFFFF0; }

    arch->rootarea+=bootoffset; //Real sector offset to RootDir
    arch->dataarea+=bootoffset; //Real sector offset to DataArea

	// trying to read fat table
	if ((arch->fattable = new tFAT12Table)==NULL)
	{
 		goto error;
	}

//add reserved sectors to bootoffset, goto FAT and read it
	SetFilePointer(arch->hArchFile,(bootoffset+bootsec.BPB_RsvdSecCnt)*bps,0,FILE_BEGIN);

	ReadFile(arch->hArchFile,arch->fattable,arch->fatsize*bps,&result,0);
	if (result!=arch->fatsize*bps)
	{
     MessageBox(NULL,"Can not read FatTable",NULL,MB_OK);
		ArchiveData->OpenResult=E_UNKNOWN_FORMAT;
		goto error;
	}
 
/*
   endoffile=arch->dataarea*bps + (CountofClusters+1) * clusterSize;
   sprintf(w,
             "FAT%d\n"
             "Fatsize %d Sectors\n"
             "Number of FATS %d\n"
             "FAT Area %d StartAdress 0x%08lX\n"
             "Root Area %d StartAdress 0x%08lX\n"
             "Data Area %d StartAdress 0x%08lX\n"
             "RootEntCnt %d\n"
             "SectorsPerCluster %d  ClusterSize 0x%04X\n"
             "Number of Clusters %d\n"
             "End of File 0x%08lX\n"
             "\n"
             ,FATtype
             ,arch->fatsize
             ,bootsec.BPB_NumFATs
             ,bootoffset+reserved,(bootoffset+reserved)*bps
             ,arch->rootarea,arch->rootarea*bps
             ,arch->dataarea,arch->dataarea*bps
             ,arch->rootentcnt
             ,bootsec.BPB_SecPerClus,bootsec.BPB_SecPerClus*bps
             ,CountofClusters
             ,endoffile
          );
   MessageBox(NULL,w,NULL,MB_OK);
*/

	// trying to read file structure
	arch->counter=0;
	arch->entrylist=NULL;

	if(FATtype==FAT32) //FAT32 has no special rootdirectory sectors 
     {                 //so read cluster with rootdirectory
	  CreateFileList("",bootsec.eb.eb32.BPB_RootClus,arch,0);
     }
    else //FAT12 / FAT16 read special rootdir sectors
     {
       CreateFileList("",0,arch,0);
     }

	if (arch->entrylist!=NULL)
	{
		while (arch->entrylist->prev!=NULL)
		{
			arch->entrylist=arch->entrylist->prev;
		}
	}
	
	ArchiveData->OpenResult=0;// ok

	return arch;

error:
	// memory must be freed
	if (arch->hArchFile!=NULL) CloseHandle(arch->hArchFile);
	if (arch->fattable!=NULL) delete arch->fattable;
	delete arch;
	return NULL;
};

//#####################################################
int IMG_Process(myHANDLE hArcData, int Operation, char *DestPath, char *DestName) 
//#####################################################
{
	tArchive *arch=hArcData;
	tDirEntry *newentry;
	unsigned long i=0;
	char dest[260]="";
	HANDLE hUnpFile;
	unsigned long nextclus;
	unsigned long remaining;
	unsigned long result;
	unsigned long towrite;
	unsigned long attributes;
    tCluster *cluster;
	FILETIME LocTime,GlobTime;

	if( Operation == PK_SKIP || Operation == PK_TEST ) return 0;
	
	newentry=arch->entrylist;
	while ( (i<arch->counter-1) && (newentry!=NULL) )
	{
		newentry=newentry->next;
		i++;
	}
	if (newentry==NULL) return E_END_ARCHIVE;

	if (newentry->FileAttr&ATTR_DIRECTORY) return 0;

	if (DestPath) strcpy(dest,DestPath);
	if (DestName) strcat(dest,DestName);
	
	hUnpFile=CreateFile(dest,GENERIC_WRITE,FILE_SHARE_READ,0,CREATE_NEW,0,0);
	if (hUnpFile==INVALID_HANDLE_VALUE) return E_ECREATE;

	if ((cluster = new tCluster)==NULL) return E_NO_MEMORY;

	i=0;

	nextclus=newentry->FirstClus;
	remaining=newentry->FileSize;

	while (remaining>0)
	{
		if ( (nextclus<=1) || (nextclus>=endcluster) )
		{
			CloseHandle(hUnpFile);
            delete cluster;
			return E_UNKNOWN_FORMAT;
		}

		SetFilePointer(arch->hArchFile
                       ,arch->dataarea * bps + (nextclus-2) * clusterSize 
                       ,0,FILE_BEGIN);

		towrite=(remaining>clusterSize)?(clusterSize):(remaining);
		ReadFile(arch->hArchFile, cluster, towrite, &result, 0);
		if (result!=towrite)
		{
			CloseHandle(hUnpFile);
                        delete cluster;
			return E_EREAD;
		}

		WriteFile(hUnpFile, cluster, towrite, &result, 0);
		if (result!=towrite) 
		{
			CloseHandle(hUnpFile);
                       delete cluster;
			return E_EWRITE;
		}

		if (remaining>clusterSize) {remaining-=clusterSize;} else {remaining=0;}

		nextclus=NextClus(nextclus,arch);

		i++;
	}
    delete cluster;

	// set file time
	DosDateTimeToFileTime(WORD((DWORD(newentry->FileTime))>>16),
	                      WORD((DWORD(newentry->FileTime))&0xFFFF),
	                      &LocTime);
	LocalFileTimeToFileTime(&LocTime,&GlobTime);
	SetFileTime(hUnpFile,NULL,NULL,&GlobTime);

	CloseHandle(hUnpFile);

	// set file attributes
	attributes=FILE_ATTRIBUTE_NORMAL;
	if (newentry->FileAttr&ATTR_READONLY) attributes|=FILE_ATTRIBUTE_READONLY;
	if (newentry->FileAttr&ATTR_ARCHIVE ) attributes|=FILE_ATTRIBUTE_ARCHIVE;
	if (newentry->FileAttr&ATTR_HIDDEN  ) attributes|=FILE_ATTRIBUTE_HIDDEN;
	if (newentry->FileAttr&ATTR_SYSTEM  ) attributes|=FILE_ATTRIBUTE_SYSTEM;
	SetFileAttributes(dest,attributes);

	return 0;//ok
};

//#####################################################
int IMG_NextItem(myHANDLE hArcData, tHeaderData *HeaderData) 
//#####################################################
{
	tArchive *arch=(tArchive *)(hArcData);
	tDirEntry *newentry;
	unsigned long i=0;
	
	newentry=arch->entrylist;
	while ( (i<arch->counter) && (newentry!=NULL) )
	{
		newentry=newentry->next;
		i++;
	}
	if (newentry==NULL)
	{
		arch->counter=0;
		return E_END_ARCHIVE;
	}

	strcpy(HeaderData->ArcName,arch->archname);
	strcpy(HeaderData->FileName,newentry->PathName);
	HeaderData->FileAttr=newentry->FileAttr;
	HeaderData->FileTime=newentry->FileTime;
	HeaderData->PackSize=newentry->FileSize;
	HeaderData->UnpSize=HeaderData->PackSize;
	HeaderData->CmtBuf=0;
	HeaderData->CmtBufSize=0;
	HeaderData->CmtSize=0;
	HeaderData->CmtState=0;
	HeaderData->UnpVer=0;
	HeaderData->Method=0;
	HeaderData->FileCRC=0;
	arch->counter++;
	return 0;//ok
};

//#####################################################
int IMG_Close(myHANDLE hArcData)
//#####################################################
{
	tArchive *arch=hArcData;
	tDirEntry *newentry;

	while (arch->entrylist!=NULL)
	{
		newentry=arch->entrylist->next;
		delete arch->entrylist;
		arch->entrylist=newentry;
	}

	CloseHandle(arch->hArchFile);
	delete arch->fattable;
	delete arch;

	return 0;// ok
};

//#####################################################
void IMG_SetCallBackVol(myHANDLE hArcData, tChangeVolProc pChangeVolProc)
{
	tArchive *arch=(tArchive *)(hArcData);

	arch->pLocChangeVol=pChangeVolProc;
};

void IMG_SetCallBackProc(myHANDLE hArcData, tProcessDataProc pProcessDataProc)
{
	tArchive *arch=(tArchive *)(hArcData);

	arch->pLocProcessData=pProcessDataProc;
};


//-----------------------=[ DLL exports ]=--------------------

// OpenArchive should perform all necessary operations when an archive is to be opened
myHANDLE __stdcall OpenArchive(tOpenArchiveData *ArchiveData)
{
	return IMG_Open(ArchiveData);
}

// WinCmd calls ReadHeader to find out what files are in the archive
int __stdcall ReadHeader(myHANDLE hArcData, tHeaderData *HeaderData)
{
	return IMG_NextItem(hArcData, HeaderData);
}

// ProcessFile should unpack the specified file or test the integrity of the archive
int __stdcall ProcessFile(myHANDLE hArcData, int Operation, char *DestPath, char *DestName)
{
	return IMG_Process(hArcData, Operation, DestPath, DestName);
}

// CloseArchive should perform all necessary operations when an archive is about to be closed
int __stdcall CloseArchive(myHANDLE hArcData)
{
	return IMG_Close(hArcData);
}

// This function allows you to notify user about changing a volume when packing files
void __stdcall SetChangeVolProc(myHANDLE hArcData, tChangeVolProc pChangeVolProc)
{
	IMG_SetCallBackVol(hArcData, pChangeVolProc);
}

// This function allows you to notify user about the progress when you un/pack files
void __stdcall SetProcessDataProc(myHANDLE hArcData, tProcessDataProc pProcessDataProc)
{
	IMG_SetCallBackProc(hArcData, pProcessDataProc);
}

//#####################################################
unsigned int MakeUINT(unsigned char *dat)
//#####################################################
{
 unsigned int tmp;

 tmp=dat[0];
 tmp+=(unsigned long)(dat[1])<<8;

 return tmp;
}

//#####################################################
unsigned long MakeULONG(unsigned char *dat)
//#####################################################
{
 unsigned long tmp;

 tmp=dat[0];
 tmp+=(unsigned long)(dat[1])<<8;
 tmp+=(unsigned long)(dat[2])<<16;
 tmp+=(unsigned long)(dat[3])<<24;

 return tmp;
}

//#####################################################
int DIR_AttrToFileAttr(unsigned char DIR_Attr,unsigned char *FileAttr)
//#####################################################
{
	(*FileAttr)=DIR_Attr;
	if (DIR_Attr==ATTR_VOLUME_ID) return AT_VOL;
	if (DIR_Attr==ATTR_LONG_NAME) return AT_LONG;
	if ((DIR_Attr&0xC8)!=0) return AT_INVALID;
	if (DIR_Attr & ATTR_DIRECTORY) return AT_DIR;
	return AT_OK;
}

//#####################################################
int ValidChar(char mychar)
//#####################################################
{
	char nonValid[17]={0x22,0x2A,0x2B,0x2C,0x2E,0x2F,0x3A,0x3B,
	                   0x3C,0x3D,0x3E,0x3F,0x5B,0x5C,0x5D,0x7C,
                       0x00}; //Don't forget 0x00 at the end !

	return !( (mychar>=0x00) && (mychar<=0x20) ) && 
	       strchr(nonValid,mychar)==NULL;
}

//#####################################################
int DIR_NameToFileName(char *DIR_Name,char *FileName)
//#####################################################
{
	int i=0,j=0;

	if (DIR_Name[0]==char(0x00)) return DN_FREE;
	if (DIR_Name[0]==char(0xE5)) return DN_DELETED;
	if (DIR_Name[0]==char(0x05)) // because 0xE5 used in Japan
	{
		FileName[i++]=char(0xE5);
	}

	while ( (i<8) && ValidChar(DIR_Name[i]) )
	{
		FileName[i]=DIR_Name[i];
		i++;
	}


	if (ValidChar(DIR_Name[8]))
	{
		FileName[i++]='.';
		while ( (j<3) && ValidChar(DIR_Name[j+8]) )
		{
			FileName[i++]=DIR_Name[j+++8];
		}
	}
	FileName[i]=0;

	if (i==0) return DN_UNKNOWN;
	return DN_OK;
}

